<script>
  // @ts-nocheck
  import { onMount } from "svelte";

  let personnes = history.state.personnes;
  let raffle = history.state.raffle;

  let raffleIndex = 0;
  let rolling = false;

  // Elements
  /**
   * @type {any}
   */
  let roller;
  /**
   * @type {any}
   */
  let container;
  let modal;

  let elements = [];

  function prepareRaffle(index) {
    // Get the raffle
    let r = raffle[index];
    console.log(r);
    // Generates the elements
    let tempPersonnes = personnes;

    container.style.transition = "sdf";
    container.style.marginLeft = "0px";
    roller.style.animation = "";
    container.innerHTML = "";
    for (let i = 0; i < 100; i++) {
      // Create a div
      let div = document.createElement("div");
      // Set id and class
      div.id = "carte-" + i;
      div.className = "item class_red_item";
      // Set innerhtml to random person and remove it if there's more than 100 people
      if (i == 64) {
        // Set the winner
        div.innerHTML = r.person.nom + " " + r.person.prenom;
		if (r.done) {
			div.classList.add("winner");
		}
      } else {
        let randomPerson =
          tempPersonnes[Math.floor(Math.random() * tempPersonnes.length)];
        div.innerHTML = randomPerson.nom + " " + randomPerson.prenom;
        if (tempPersonnes.length > 100) {
          tempPersonnes.splice(tempPersonnes.indexOf(randomPerson), 1);
        }
      }
      // Add the div to the elements
      elements.push(div);
      // Add it to the container
      container.appendChild(div);

	  // Place the container right if the raffle is done
	  if (r.done) {
		container.style.marginLeft = -12770 + "px";
	  }
    }
  }

  function doRaffle() {
    // Set rolling
    rolling = true;
    // Set the transition
    container.style.transition = "all 10s cubic-bezier(.08,.6,0,1)";
    // Randomize margin -50px to 50px
    let margin = Math.floor(Math.random() * 100) - 50;
    // Set the margin
    container.style.marginLeft = -12770 + margin + "px";
    // Set the animation to the roller*
    roller.style.animation = "wobble-hor-bottom 10s both";

    // validate raffle
    raffle[raffleIndex].done = true;

    // Open modal after 10s
    setTimeout(() => {
      roller.style.animation = "";
      elements[64].classList.add("winner");
      // wait 1s to open modal
      setTimeout(() => {
        rolling = false;
        toggleModal();
      }, 1000);
    }, 10000);
  }

  function nextButton() {
    if (raffleIndex < raffle.length) {
      raffleIndex++;
      prepareRaffle(raffleIndex);
    }
  }
  function previousButton() {
    if (raffleIndex > 0) {
      raffleIndex--;
      prepareRaffle(raffleIndex);
    }
  }
  function playButton() {
    doRaffle();
  }

  function toggleModal() {
    modal.open = !modal.open;
  }

  onMount(() => {
    prepareRaffle(raffleIndex);
  });
</script>

<svelte:head>
  <style>
    @import url("https://fonts.googleapis.com/css?family=Arvo");
    @keyframes wobble-hor-bottom {
      0%,
      100% {
        -webkit-transform: translateX(0);
        transform: translateX(0);
        -webkit-transform-origin: 50% 50%;
        transform-origin: 50% 50%;
      }
      15% {
        -webkit-transform: translateX(-30px) rotate(-2.4deg);
        transform: translateX(-30px) rotate(-2.4deg);
      }
      30% {
        -webkit-transform: translateX(15px) rotate(2deg);
        transform: translateX(15px) rotate(2deg);
      }
      45% {
        -webkit-transform: translateX(-15px) rotate(-1.6deg);
        transform: translateX(-15px) rotate(-1.6deg);
      }
      60% {
        -webkit-transform: translateX(9px) rotate(1.2deg);
        transform: translateX(9px) rotate(1.2deg);
      }
      75% {
        -webkit-transform: translateX(-6px) rotate(-0.8deg);
        transform: translateX(-6px) rotate(-0.8deg);
      }
    }
    @keyframes wobble-hor-bottom {
      0%,
      100% {
        -webkit-transform: translateX(0);
        transform: translateX(0);
        -webkit-transform-origin: 50% 50%;
        transform-origin: 50% 50%;
      }
      15% {
        -webkit-transform: translateX(-30px) rotate(-6deg);
        transform: translateX(-30px) rotate(-6deg);
      }
      30% {
        -webkit-transform: translateX(15px) rotate(6deg);
        transform: translateX(15px) rotate(6deg);
      }
      45% {
        -webkit-transform: translateX(-15px) rotate(-3.6deg);
        transform: translateX(-15px) rotate(-3.6deg);
      }
      60% {
        -webkit-transform: translateX(9px) rotate(2.4deg);
        transform: translateX(9px) rotate(2.4deg);
      }
      75% {
        -webkit-transform: translateX(-6px) rotate(-1.2deg);
        transform: translateX(-6px) rotate(-1.2deg);
      }
    }

    body {
      background: rgb(25, 25, 33);
    }
    .raffle-roller {
      height: 200px;
      position: relative;
      margin: 60px auto 30px auto;
      width: 900px;
    }
    .raffle-roller-holder {
      position: absolute;
      top: 0;
      left: 0;
      right: 0;
      bottom: 0;
      height: 200px;
      width: 100%;
    }
    .raffle-roller-holder {
      overflow: hidden;
      border-radius: 2px;
      border: 1px solid #3c3759;
    }
    .raffle-roller-holder {
      position: absolute;
      top: 0;
      left: 0;
      right: 0;
      bottom: 0;
      height: 200px;
      width: 100%;
    }
    .raffle-roller-container {
      width: 9999999999999999999px;
      max-width: 999999999999999999px;
      height: 200px;
      background: #191726;
      margin-left: 0;
      transition: all 8s cubic-bezier(0.08, 0.6, 0, 1);
      /* pinkish gradient */
      background: linear-gradient(
        to bottom right,
        rgba(255, 176, 241, 1) 0%,
        rgba(245, 255, 201, 1) 16%,
        rgba(124, 222, 255, 1) 100%
      );
    }
    .raffle-roller-holder:before {
      content: "";
      position: absolute;
      border: none;
      z-index: 0;
      width: 5px;
      height: 100%;
      left: 50%;
      background: #d16266;
    }
    .item {
      display: inline-block;
      float: left;
      margin: 4px 0px 0.5px 5px;
      width: 85px;
      height: 196px;
      width: 200px;
      border: 1px solid #70677c;
      background: #14202b44;
      background-size: 100%;
      background-repeat: no-repeat;
      background-position: center;
      /* center text */
      text-align: center;
      line-height: 196px;
      color: #fff;
      font-size: 20px;
      font-family: "Arvo", serif;
      font-weight: 700;
    }
    .class_red_item {
      border-bottom: 8px solid #ffb6c1;
    }
    img {
      border: 0;
      vertical-align: middle;
    }
    .winning-item {
      border: 2px solid #66b233;
      position: relative;
      top: -1px;
      border-bottom: 4px solid #66b233;
    }
    .inventory {
      margin: 0 auto;
      width: 960px;
      max-width: 953px;
      padding: 10px 15px 6px;
      height: auto;
      border: 2px solid #1c3344;
      background: #0e1a23;
    }
    .inventory > .item {
      float: none;
      cursor: pointer;
      margin: 4px 2px 0.5px 2px;
    }
    .inventory > .item:hover {
      background-size: 90%;
      background-color: #182a38;
    }
    .inventory > .item:active {
      height: 83px;
      width: 80px;
      position: relative;
      top: -2px;
      border: 2px solid #356d27;
      border-bottom: 4px solid #356d27;
    }
    .image {
      /* crop at 350 */
      width: 450px;
      max-height: 350px;
      /* do not stretch */
      object-fit: contain;
      border-radius: 5px;
    }
    .winner {
      /* green border */
      border: 6px solid #66b233;
      /* green background */
      background: #0e1a23;
    }
    .swirl-in-fwd {
      -webkit-animation: swirl-in-fwd 0.6s ease-out both;
      animation: swirl-in-fwd 0.6s ease-out both;
    }
    @keyframes swirl-in-fwd {
      0% {
        -webkit-transform: rotate(-540deg) scale(0);
        transform: rotate(-540deg) scale(0);
        opacity: 0;
      }
      100% {
        -webkit-transform: rotate(0) scale(1);
        transform: rotate(0) scale(1);
        opacity: 1;
      }
    }
    @keyframes swirl-in-fwd {
      0% {
        -webkit-transform: rotate(-540deg) scale(0);
        transform: rotate(-540deg) scale(0);
        opacity: 0;
      }
      100% {
        -webkit-transform: rotate(0) scale(1);
        transform: rotate(0) scale(1);
        opacity: 1;
      }
    }
  </style>
</svelte:head>

<body class="container">
  <article>
    <!-- Modal -->
    <dialog id="modal-example" bind:this={modal}>
      <article class="swirl-in-fwd">
        <a
          href=""
          aria-label="Close"
          class="close"
          data-target="modal-example"
          on:click={() => toggleModal()}
        />
        <h3>
          {raffle[raffleIndex].person.nom}
          {raffle[raffleIndex].person.prenom} a gagné !
        </h3>
        <footer>
          <a
            href=""
            role="button"
            data-target="modal-example"
            on:click={() => {
              toggleModal();
              nextButton();
            }}
          >
            Suivant
          </a>
        </footer>
      </article>
    </dialog>

    <!-- Lot -->
    <div class="grid">
      <div>
        <h2>{raffle[raffleIndex].lot.nom}</h2>
        <p>{raffle[raffleIndex].lot.comment}</p>
        <p>> {raffle[raffleIndex].lot.content}</p>
        {#if raffle[raffleIndex].done}
          <h4>Lot déjà tiré</h4>
        {:else}
          <h4>Lot à tirer</h4>
        {/if}
      </div>
      <div>
        <img
          class="image"
          src="https://st2.depositphotos.com/1219867/8235/i/450/depositphotos_82350542-stock-photo-beautiful-gold-present-box-with.jpg"
          alt={raffle[raffleIndex].lot.nom}
        />
      </div>
    </div>

    <!-- Holder -->
    <div class="raffle-roller" bind:this={roller}>
      <div class="raffle-roller-holder">
        <div
          class="raffle-roller-container"
          bind:this={container}
          style="margin-left: 0px;"
        />
      </div>
    </div>

    <!-- Controls -->
    <div class="grid">
      <button
        disabled={raffleIndex == 0 || rolling}
        on:click={() => previousButton()}>Précédent</button
      >
      <button
        disabled={rolling || raffle[raffleIndex].done}
        on:click={() => playButton()}>Lancer</button
      >
      <button
        disabled={raffleIndex == raffle.length - 1 || rolling}
        on:click={() => nextButton()}>Suivant</button
      >
    </div>
  </article>
</body>
